package org.jboss.jca.embedded.dsl.datasources10.api; 

import java.util.ArrayList;
import java.util.List;
import org.jboss.shrinkwrap.descriptor.api.Child;
/**
 * This interface defines the contract for the <code> xa-datasource-propertyType </code> xsd type 
 * @author <a href="mailto:ralf.battenfeld@bluewin.ch">Ralf Battenfeld</a>
 * @author <a href="mailto:alr@jboss.org">Andrew Lee Rubinger</a>
 * @since Generation date :2012-11-28T09:44:17.256-05:00
 */
public interface XaDatasourcePropertyType<T> extends Child<T>
{
 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: XaDatasourcePropertyType ElementName: text ElementType : xa-datasource-propertyType
   // MaxOccurs: -  isGeneric: true   isAttribute: false isEnum: false isDataType: false
   // --------------------------------------------------------------------------------------------------------||

   /**
    * Sets the body text for the element <code>xa-datasource-propertyType</code> 
    * @param xaDatasourcePropertyType the value for the body text <code>xa-datasource-propertyType</code> 
    * @return the current instance of <code>XaDatasourcePropertyType<T></code> 
    */
   public XaDatasourcePropertyType<T> text(String value);

   /**
    * Returns the body text of the element <code>xa-datasource-propertyType</code> 
    * @return the value defined for the text <code>xa-datasource-propertyType</code> 
    */
   public String getText();

 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: XaDatasourcePropertyType ElementName: xsd:token ElementType : name
   // MaxOccurs: -  isGeneric: true   isAttribute: true isEnum: false isDataType: true
   // --------------------------------------------------------------------------------------------------------||

   /**
    * Sets the <code>name</code> attribute
    * @param name the value for the attribute <code>name</code> 
    * @return the current instance of <code>XaDatasourcePropertyType<T></code> 
    */
   public XaDatasourcePropertyType<T> name(String name);

   /**
    * Returns the <code>name</code> attribute
    * @return the value defined for the attribute <code>name</code> 
    */
   public String getName();

   /**
    * Removes the <code>name</code> attribute 
    * @return the current instance of <code>XaDatasourcePropertyType<T></code> 
    */
   public XaDatasourcePropertyType<T> removeName();
}
