package org.jboss.jca.embedded.dsl.resourceadapters11.api; 

import java.util.ArrayList;
import java.util.List;
import org.jboss.shrinkwrap.descriptor.api.Child;
/**
 * This interface defines the contract for the <code> workmanagerSecurityGroupsType </code> xsd type 
 * @author <a href="mailto:ralf.battenfeld@bluewin.ch">Ralf Battenfeld</a>
 * @author <a href="mailto:alr@jboss.org">Andrew Lee Rubinger</a>
 * @since Generation date :2012-11-28T09:44:16.232-05:00
 */
public interface WorkmanagerSecurityGroupsType<T> extends Child<T>
{
 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityGroupsType ElementName: xsd:token ElementType : group
   // MaxOccurs: -unbounded  isGeneric: true   isAttribute: false isEnum: false isDataType: true
   // --------------------------------------------------------------------------------------------------------||

   /**
    * Creates for all String objects representing <code>group</code> elements, 
    * a new <code>group</code> element 
    * @param values list of <code>group</code> objects 
    * @return the current instance of <code>WorkmanagerSecurityGroupsType<T></code> 
    */
   public WorkmanagerSecurityGroupsType<T> group(String ... values);

   /**
    * Returns all <code>group</code> elements
    * @return list of <code>group</code> 
    */
   public List<String> getAllGroup();

   /**
    * Removes the <code>group</code> element 
    * @return the current instance of <code>WorkmanagerSecurityGroupsType<T></code> 
    */
   public WorkmanagerSecurityGroupsType<T> removeAllGroup();
}
