package org.jboss.jca.embedded.dsl.resourceadapters11.api; 

import java.util.ArrayList;
import java.util.List;
import org.jboss.shrinkwrap.descriptor.api.Child;
import org.jboss.jca.embedded.dsl.resourceadapters11.api.WorkmanagerSecurityMappingsUsersType;
import org.jboss.jca.embedded.dsl.resourceadapters11.api.WorkmanagerSecurityMappingsGroupsType;
/**
 * This interface defines the contract for the <code> workmanagerSecurityMappingsType </code> xsd type 
 * @author <a href="mailto:ralf.battenfeld@bluewin.ch">Ralf Battenfeld</a>
 * @author <a href="mailto:alr@jboss.org">Andrew Lee Rubinger</a>
 * @since Generation date :2012-11-28T09:44:16.232-05:00
 */
public interface WorkmanagerSecurityMappingsType<T> extends Child<T>
{
 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityMappingsType ElementName: resource-adapters:workmanagerSecurityMappingsUsersType ElementType : users
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: false
   // --------------------------------------------------------------------------------------------------------||

   /**
    * If not already created, a new <code>users</code> element with the given value will be created.
    * Otherwise, the existing <code>users</code> element will be returned.
    * @return  a new or existing instance of <code>WorkmanagerSecurityMappingsUsersType<WorkmanagerSecurityMappingsType<T>></code> 
    */
   public WorkmanagerSecurityMappingsUsersType<WorkmanagerSecurityMappingsType<T>> getOrCreateUsers();

   /**
    * Removes the <code>users</code> element 
    * @return the current instance of <code>WorkmanagerSecurityMappingsType<T></code> 
    */
   public WorkmanagerSecurityMappingsType<T> removeUsers();

 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityMappingsType ElementName: resource-adapters:workmanagerSecurityMappingsGroupsType ElementType : groups
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: false
   // --------------------------------------------------------------------------------------------------------||

   /**
    * If not already created, a new <code>groups</code> element with the given value will be created.
    * Otherwise, the existing <code>groups</code> element will be returned.
    * @return  a new or existing instance of <code>WorkmanagerSecurityMappingsGroupsType<WorkmanagerSecurityMappingsType<T>></code> 
    */
   public WorkmanagerSecurityMappingsGroupsType<WorkmanagerSecurityMappingsType<T>> getOrCreateGroups();

   /**
    * Removes the <code>groups</code> element 
    * @return the current instance of <code>WorkmanagerSecurityMappingsType<T></code> 
    */
   public WorkmanagerSecurityMappingsType<T> removeGroups();
}
