package org.jboss.jca.embedded.dsl.resourceadapters11.api; 

import java.util.ArrayList;
import java.util.List;
import org.jboss.shrinkwrap.descriptor.api.Child;
import org.jboss.jca.embedded.dsl.resourceadapters11.api.WorkmanagerSecurityGroupsType;
import org.jboss.jca.embedded.dsl.resourceadapters11.api.WorkmanagerSecurityMappingsType;
/**
 * This interface defines the contract for the <code> workmanagerSecurityType </code> xsd type 
 * @author <a href="mailto:ralf.battenfeld@bluewin.ch">Ralf Battenfeld</a>
 * @author <a href="mailto:alr@jboss.org">Andrew Lee Rubinger</a>
 * @since Generation date :2012-11-28T09:44:16.232-05:00
 */
public interface WorkmanagerSecurityType<T> extends Child<T>
{
 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityType ElementName: xsd:boolean ElementType : mapping-required
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: true
   // --------------------------------------------------------------------------------------------------------||

   /**
    * Sets the <code>mapping-required</code> element
    * @param mappingRequired the value for the element <code>mapping-required</code> 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> mappingRequired(Boolean mappingRequired);

   /**
    * Returns the <code>mapping-required</code> element
    * @return the node defined for the element <code>mapping-required</code> 
    */
   public Boolean isMappingRequired();

   /**
    * Removes the <code>mapping-required</code> element 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> removeMappingRequired();

 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityType ElementName: xsd:token ElementType : domain
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: true
   // --------------------------------------------------------------------------------------------------------||

   /**
    * Sets the <code>domain</code> element
    * @param domain the value for the element <code>domain</code> 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> domain(String domain);

   /**
    * Returns the <code>domain</code> element
    * @return the node defined for the element <code>domain</code> 
    */
   public String getDomain();

   /**
    * Removes the <code>domain</code> element 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> removeDomain();

 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityType ElementName: xsd:token ElementType : default-principal
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: true
   // --------------------------------------------------------------------------------------------------------||

   /**
    * Sets the <code>default-principal</code> element
    * @param defaultPrincipal the value for the element <code>default-principal</code> 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> defaultPrincipal(String defaultPrincipal);

   /**
    * Returns the <code>default-principal</code> element
    * @return the node defined for the element <code>default-principal</code> 
    */
   public String getDefaultPrincipal();

   /**
    * Removes the <code>default-principal</code> element 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> removeDefaultPrincipal();

 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityType ElementName: resource-adapters:workmanagerSecurityGroupsType ElementType : default-groups
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: false
   // --------------------------------------------------------------------------------------------------------||

   /**
    * If not already created, a new <code>default-groups</code> element with the given value will be created.
    * Otherwise, the existing <code>default-groups</code> element will be returned.
    * @return  a new or existing instance of <code>WorkmanagerSecurityGroupsType<WorkmanagerSecurityType<T>></code> 
    */
   public WorkmanagerSecurityGroupsType<WorkmanagerSecurityType<T>> getOrCreateDefaultGroups();

   /**
    * Removes the <code>default-groups</code> element 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> removeDefaultGroups();

 
   // --------------------------------------------------------------------------------------------------------||
   // ClassName: WorkmanagerSecurityType ElementName: resource-adapters:workmanagerSecurityMappingsType ElementType : mappings
   // MaxOccurs: -1  isGeneric: true   isAttribute: false isEnum: false isDataType: false
   // --------------------------------------------------------------------------------------------------------||

   /**
    * If not already created, a new <code>mappings</code> element with the given value will be created.
    * Otherwise, the existing <code>mappings</code> element will be returned.
    * @return  a new or existing instance of <code>WorkmanagerSecurityMappingsType<WorkmanagerSecurityType<T>></code> 
    */
   public WorkmanagerSecurityMappingsType<WorkmanagerSecurityType<T>> getOrCreateMappings();

   /**
    * Removes the <code>mappings</code> element 
    * @return the current instance of <code>WorkmanagerSecurityType<T></code> 
    */
   public WorkmanagerSecurityType<T> removeMappings();
}
